/****************************************************************************
* Aplicativo : (?)		                    *
* Autor		 : Ana Lcia S. Melo 										    *
* Referncia : (?)- Programa Servidor para Terminais de Consulta            *
* Data       : 04/03/08													    *
* Ambiente   : Eclipse 						                                *
* Fonte      : Principal.java (gera Principal.class)    				    *
* Objetivo   : Responsvel por iniciar o programa, conexo, layout do 		*
*              programa e pelos eventos de botes, listas e etc.		   	*
*****************************************************************************/
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.List;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;



public class Principal extends JFrame{
	Container c;
	
	/********		MENU		***********/
	JMenuBar bar;
	JMenu fileMenu;				//Menu Arquivos
	JMenu configMenu;			//Menu Configuraes
	
	/********		SUBMENUS	***********/
	JMenuItem mIniciarServidor; //Item no Menu para iniciar servidor
	JMenuItem mReiniciar;		//Item no Menu para Reiniciar terminal
	
	/********		ABAS		***********/
	private JTabbedPane tabs ; 
	
	//Aba Configurao
	JTextField txIpServidor;	//Caixa de texto referente ao IP Servidor
	JTextField txIpTerminal;	//Caixa de texto referente ao IP Terminal
	JTextField txMask;			//Caixa de texto referente a mascara de rede
	JTextField txTexto1;		//Caixa de texto referente ao texto 1
	JTextField txTexto2;		//Caixa de texto referente ao texto 2
	JTextField txTexto3;		//Caixa de texto referente ao texto 3
	JTextField txTexto4;		//Caixa de texto referente ao texto 4
	JTextField txTempExib;		//Caixa de texto referente ao tempo de exibio
	JButton bConfiguracao;	 	//Boto de receber configurao do terminal
	JButton bEnviaConfig;	 	//Boto de enviar configurao do terminal
	
	//Aba Mensagem
	JTextField txMsgL1;  	 	//Caixa de texto referente a linha1 da mensagem a ser enviada 
	JTextField txMsgL2;		 	//Caixa de texto referente a linha2 da mensagem a ser enviada
	JTextField txTempMsg;    	//Caixa de texto referente ao tempo de exibio da mensagem a ser enviada
	JButton bMensagem; 		 	//Boto de Envia mensagem
	
	
		
	/********		BOTES		***********/	
	JButton bImagem;			//Boto de Imagem
	JButton bListarTerminais;	//Boto de Lista de terminais
	
	
	/********		LISTAS		***********/
	ArrayList<Terminal> alist; 	//Lista de terminais conectados
	List conectList = new List();
	/********		LABEL'S		***********/
	JLabel lMsg1;				//Indicao de Mensagem Linha 1
	JLabel lMsg2;				//Indicao de Mensagem Linha 2
	JLabel lTempMsg;			//Indicao de Tempo de Exibio
		
	/********		OUTROS		***********/
	Servidor server;			//Relacionamento com a classe Servidor
		
/********************************************************************************************************
 * 								Declarao das Variaveis												*
 ********************************************************************************************************/	
	String comando;			//Variavel Global para envio de comandos ao terminal
	byte tamMsgLine1;		//Variavel Global para recebimento do tamanho da mensagem (linha 1)a enviar 
	byte tamMsgLine2;		//Variavel Global para recebimento do tamanho da mensagem (linha 2)a enviar
	String msgLine1;		//Variavel Global para recebimento da mensagem (linha 1)a enviar
	String msgLine2;		//Variavel Global para recebimento da mensagem (linha 2)a enviar
	int tempMsgInt;			//Variavel Global do tipo inteiro para envio do tempo de exibio da mensagem
	byte tempExibMsg;		//Variavel Global para recebimento do tempo de exibio da mensagem a enviar
	byte senha[]= new byte[4];
	int i = 0;
	
	private char tamIpServ;
	private  String eipServ;
	private char tamIpTerm;
	private String eipTerm;
	private char tamMask;
	private String eMask;
	private char tamTxt1;
	private String etxt1;
	private char tamTxt2;
	private String etxt2;
	private char tamTxt3;
	private String etxt3;
	private char tamTxt4;
	private String etxt4;
	private char etempExib;
	
/********************************************************************************************************
 * 										Layout do Programa			  									*
 * ******************************************************************************************************/	
/********************************************************************************************************
 * 	Principal(): Construtor																				*
 * ******************************************************************************************************/	
	
	Principal(){
		setTitle("Exemplo Servidor Java!");
		setSize(550, 450);
		c = getContentPane();
		c.setLayout(new FlowLayout());
		
		/***************Abas e Panel************/
		tabs = new JTabbedPane(); 
		  

		
		/***************Menus e SubMenus *******/
		bar = new JMenuBar();
		fileMenu = new JMenu("Arquivo");
		configMenu = new JMenu ("Configurao");
		mIniciarServidor = new JMenuItem ("Iniciar");
		mReiniciar = new JMenuItem ("Reiniciar Terminal");
	
		/***************Botes******************/
		bListarTerminais = new JButton ("Listar Terminais");
		
		/***************Cx Texto***************/
		
	
		/***************Label****************/
		lMsg1 = new JLabel("Mensagem Linha 1");
		lMsg2 = new JLabel("Mensagem Linha 2");
		lTempMsg = new JLabel("Tempo de Exibio");
		
	   
		
/********************************************************************************************************
 * 				Criando as abas com seus respectivos componentes(03/04/2008)							*
 ********************************************************************************************************/
		//Aba 1 - Configurao
        JPanel jp = new JPanel(new GridLayout(9,2));

		//Montagem das abas 
        jp.add(new JLabel("IP Servidor")); 
		jp.add(txIpServidor = new JTextField(15)); 
		jp.add(new JLabel("IP Terminal")); 
		jp.add(txIpTerminal = new JTextField(15));
		jp.add(new JLabel("Mascara de Rede")); 
		jp.add(txMask = new JTextField(15));
		jp.add(new JLabel("Texto 1")); 
		jp.add(txTexto1 = new JTextField(10));
		jp.add(new JLabel("Texto 2")); 
		jp.add(txTexto2 = new JTextField(10));
		jp.add(new JLabel("Texto 3")); 
		jp.add(txTexto3 = new JTextField(10));
		jp.add(new JLabel("Texto 4")); 
		jp.add(txTexto4 = new JTextField(10));
		jp.add(new JLabel("Tempo de Exibio")); 
		jp.add(txTempExib = new JTextField(2));
		jp.add(bEnviaConfig = new JButton("Enviar Configurao"));
		jp.add(bConfiguracao = new JButton("Receber Configurao"));
	
		//adiciono a panel a JTabbedPane() na aba 1 - Configurao 
		tabs.addTab("Configurao", jp ); 

		//adiciono a tabs no frame principal 
		getContentPane().add(tabs); 

		//instancia denovo para ela no fazer mais referencia aos txt e labels 
		jp = new JPanel(new GridLayout(6,2)); 
	
		
		//Aba2 - Mensagem
		
		//adiciono novamente
		jp.add(new JLabel("Texto Linha 1")); 
		jp.add (txMsgL1 = new JTextField (20)); 
		jp.add(new JLabel("Texto Linha 2")); 
		jp.add(txMsgL2 = new JTextField(20)); 
		jp.add(new JLabel("Tempo de Exibio")); 
		jp.add(txTempMsg = new JTextField(2)); 		
		jp.add(bMensagem = new JButton ("Enviar Mensagem"));
	
		tabs.addTab("Mensagem",jp); 

		getContentPane().add(tabs); 
		
		
		
 		
/********************************************************************************************************
 * 									Funes dos Botes e Menus											*
 ********************************************************************************************************/
		fileMenu.setMnemonic('A');
		fileMenu.add(mIniciarServidor);
		fileMenu.add(mReiniciar);
		
		setJMenuBar(bar);
		bar.add(fileMenu);
		
/********************************************************************************************************
 * 									mIniciarServidor: Iniciar o servidor								*
 ********************************************************************************************************/	
		mIniciarServidor.addActionListener( new ActionListener(){
			public void actionPerformed(ActionEvent event){
				try{
					//Inicia o servidor
					server = new Servidor();
				 	server.start();
				 	JOptionPane.showMessageDialog(null, "Servidor Iniciado");
				 	
				}catch(Exception e){
					JOptionPane.showMessageDialog(null, "Erro ao iniciar o servidor");
				}
				
			}
			
		});
		
/********************************************************************************************************
 * 						bMensagem: Envia mensagem ao display do terminal (11/03/08)						*
 ********************************************************************************************************/	
		bMensagem.addActionListener(new ActionListener(){
			public void actionPerformed (ActionEvent event){
				try{
					if (txMsgL1.getText().equals(""))msgLine1 = " ";
					else msgLine1= txMsgL1.getText(); 					//Recebe linha 1
					
					if (txMsgL2.getText().equals(""))msgLine2= " ";
					else msgLine2= txMsgL2.getText();					//Recebe linha 2
					
					if (txTempMsg.getText().equals(""))tempMsgInt = 0;
					else tempMsgInt = Integer.parseInt(txTempMsg.getText() ); //Recebe tempo de exibio
					
					sendText(msgLine1, msgLine2,tempMsgInt);
	
				}catch(Exception e){
					JOptionPane.showMessageDialog(null,e.getMessage());
				}
			}
			public void sendText(String linha1, String linha2, int tempo){
				//inclui na variavel comando a funo a enviar: "#mesg" + dados
		        comando = "#mesg" + 
		                String.format("%c",linha1.length()+'0') + linha1 + 
		                String.format("%c",linha2.length()+'0') + linha2 + 
		                String.format("%c",tempo + '0') + '0';
		        try{
		        	//envia a mensagem para o terminal selecionado na lista
		        	System.out.println(comando);
		        	ArrayList<Terminal> lista = server.gettab();
					lista.get(conectList.getSelectedIndex()).escreveSocket(comando);
					
		        }catch(Exception e){
		        	JOptionPane.showMessageDialog(null,"Erro ao enviar mesagem. Selecione um terminal");
		        }
		    }
		});

/********************************************************************************************************
 * 						bReiniciar: Reinicia o terminal (19/3/08)										*
 ********************************************************************************************************/	
		mReiniciar.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event){
				try{
					senha[0]=(byte)0xA5;
					senha[1]=(byte)0xCC;
					senha[2]=(byte)0x5A;
					senha[3]=(byte)0x33;
					
					//Armazena e envia o comando "#restartsoft" + senha
					comando = "#restartsoft" + new String(senha); 
					ArrayList<Terminal> lista = server.gettab();
					lista.get(conectList.getSelectedIndex()).escreveSocket(comando);
				}catch(Exception e){
					JOptionPane.showMessageDialog(null,"Selecione um terminal");
				}
			}
		});	
/********************************************************************************************************
 *  						bConfiguracao: Solicita configurao do terminal 							*
 ********************************************************************************************************/	
		bConfiguracao.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event){
				Terminal terminal;
				try{
					
					//Armazena e solicita configurao pela funo "#config02"
					comando = "#config02?";
					ArrayList<Terminal> lista = server.gettab();
					lista.get(conectList.getSelectedIndex()).escreveSocket(comando);
					
					Thread.sleep (200);
					terminal = alist.get(conectList.getSelectedIndex());
					txIpServidor.setText("" + terminal.ipServ);
					txIpTerminal.setText("" + terminal.ipTerm);
					txMask.setText("" + terminal.Mask);
					txTexto1.setText("" + terminal.txt1);
					txTexto2.setText("" + terminal.txt2);
					txTexto3.setText("" + terminal.txt3);
					txTexto4.setText("" + terminal.txt4);
					txTempExib.setText("" + terminal.tempExib);
					
				}catch(Exception e){
					JOptionPane.showMessageDialog(null,"Selecione um terminal");
				}
			}
		});
/********************************************************************************************************
 *  						bEnviaConfig: Envia configurao ao terminal								*
 ********************************************************************************************************/	
				bEnviaConfig.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent event){
						//Terminal terminal;
						try{
												
							
							//Armazena os dados recebidos
							eipServ = txIpServidor.getText();			// IP Servidor
							tamIpServ = (char)(eipServ.length() + 48);	//Tamanho do IP Servidor
							System.out.println(eipServ);							
							
							eipTerm = txIpTerminal.getText(); // IP Terminal
							tamIpTerm = (char)(eipTerm.length() + 48); //Tamanho do IP terminal
							System.out.println(eipTerm);
							
							eMask = txMask.getText() ;//Mascara de rede
							tamMask = (char)(eMask.length() + 48); // Tamanho da mascara de rede
							System.out.println(eMask);
							
							etxt1 = txTexto1.getText(); //Texto 1 linha 1 pgina 1
							tamTxt1 = (char)(etxt1.length() + 48); //Tamanho do texto 1
							System.out.println(etxt1);
							
							etxt2 = txTexto2.getText();//Texto 2 linha 2 pgina 1
							tamTxt2 = (char)(etxt2.length() + 48); //Tamanho do texto2
							System.out.println(etxt2);
						
							etxt3 = txTexto3.getText();//Texto 3 linha 1 pgina 2
							tamTxt3 = (char)(etxt3.length() + 48); //Tamanho do texto3
							System.out.println(etxt3);
						
							etxt4 = txTexto4.getText();//Texto 4 linha 2 pgina 2
							tamTxt4 = (char)(etxt4.length() + 48); //Tamanho do texto 4
							System.out.println(etxt4);

							etempExib = (char)(Integer.parseInt(txTempExib.getText())+ 48); // Tempo de exibio
		 					System.out.println(etempExib);
							
		 					comando = "#reconf02"+ tamIpServ + eipServ +tamIpTerm + eipTerm +
		 						tamMask + eMask + tamTxt1 + etxt1 + tamTxt2 + etxt2 + tamTxt3 + 
		 						etxt3 + tamTxt4 + etxt4 + etempExib;
		 					System.out.println(comando);
							
		 					ArrayList<Terminal> lista = server.gettab();
							lista.get(conectList.getSelectedIndex()).escreveSocket(comando);
							System.out.println(comando);
						}catch(Exception e){
							JOptionPane.showMessageDialog(null,"Selecione um terminal");
						}
					}
				});

		
/********************************************************************************************************
 *  				bListarTerminais: Inclui o IP do terminal conectado na lista list 					*
 ********************************************************************************************************/	
		
		bListarTerminais.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event){
				Terminal term;
				
				try{
					//Lista os terminais que se conectam 
					alist = server.getList();
					term = alist.get(conectList.getItemCount());
					conectList.add(term.IP.toString());
					
										
				}catch(Exception e){
					JOptionPane.showMessageDialog(null,"No h mais terminais conectados");
				}
			}
		});
		
/********************************************************************************************************
 * 									Monta o Layout do Programa											*
 ********************************************************************************************************/	
		c.add(bListarTerminais);
		c.add(conectList);
		
	} //Construtor
/*****************************************************************************************/

	
/********************************************************************************************************
 * 	static void main(String[] args)												  									*
 * ******************************************************************************************************/	
	public static void main(String[] args) {
		Principal gui = new Principal();
		gui.setVisible(true);
		gui.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
}
