import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.net.InetAddress;
import java.net.Socket;

import javax.swing.JOptionPane;


public class Terminal extends Thread{
	private Socket sock;
	public InetAddress IP;
	private BufferedInputStream in;
	private BufferedOutputStream out;
	private boolean conectado;
	private Consulta codigo; 
	
	private String tipo;
	private String versao;
	
	/************************************************************************
	 * 					 Variaveis de configurao (#Conf02)				*
	 ************************************************************************/
	private byte tamIpServ;
	public String ipServ;
	private byte tamIpTerm;
	public String ipTerm;
	private byte tamMask;
	public String Mask;
	private byte tamTxt1;
	public String txt1;
	private byte tamTxt2;
	public String txt2;
	private byte tamTxt3;
	public String txt3;
	private byte tamTxt4;
	public String txt4;
	public byte tempExib;
	
	/**********************************************************************/
	
	Terminal(Socket sockCliente)throws Exception{
		sock = sockCliente;
		in = new BufferedInputStream(sock.getInputStream());
		out = new BufferedOutputStream(sock.getOutputStream());
	    
		codigo = new Consulta();
	}
	
	private String lerSocket()throws Exception{
		String comando;
		byte vetor[] = new byte[255];
		int qtdLida;
		
		qtdLida = in.read(vetor);
		comando = new String(vetor);
		return comando.substring(0, qtdLida);
	}
	
	//Envia para o terminal
	public void escreveSocket(String comando)throws Exception{
		byte vetor[] = comando.getBytes();
		out.write(vetor);
		out.flush();
	}
	public String toString(){
		return IP.toString().substring(1)+"/"+tipo.toUpperCase()+"|"+versao;
	}
	
	public void run(){
		String comandoRecebido;
		IP = sock.getInetAddress();
		
		String cod;
		String retCod;
		try{
			escreveSocket("#ok");
			comandoRecebido = lerSocket();
			
			tipo = comandoRecebido.substring(1, comandoRecebido.indexOf('|'));
			versao = comandoRecebido.substring(comandoRecebido.indexOf('|')+1);
			System.out.println(tipo);
			System.out.println(versao);
			escreveSocket("#alwayslive");
			comandoRecebido = lerSocket();
			
			if (comandoRecebido.compareTo("#alwayslive_ok") == 0){
				conectado = true;
			}
			
		}catch(Exception e){
			System.out.println(e.getMessage());
		}

		try{
			while(conectado){
				comandoRecebido = lerSocket();
				System.out.println(comandoRecebido);
				
				//Verifica se o terminal foi reiniciado
				if (comandoRecebido.startsWith("#restartsoft_ok") ){
					System.out.println(comandoRecebido.substring(1));
					JOptionPane.showMessageDialog(null, "Terminal Reiniciado");
				}
				//Verifica se recebeu a configurao
				else if (comandoRecebido.startsWith("#config02") ){
					//Armazena os dados recebidos
					tamIpServ = (byte)(comandoRecebido.charAt(9)-48); //Tamanho do IP Servidor
					ipServ = comandoRecebido.substring(10,tamIpServ+10); //IP Servidor
					System.out.println(ipServ);
					
					
					tamIpTerm = (byte)(comandoRecebido.charAt(9+1+tamIpServ)-48); //Tamanho do IP terminal
					ipTerm = comandoRecebido.substring(10+1+tamIpServ,9+2+tamIpServ+tamIpTerm); // IP Terminal
					System.out.println(ipTerm);
					
					
					tamMask = (byte)(comandoRecebido.charAt(9+2+tamIpServ+tamIpTerm)-48); // Tamanho da mascara de rede
					Mask =  comandoRecebido.substring(10+2+tamIpServ+tamIpTerm,9+3+tamIpServ+tamIpTerm+tamMask);//Mascara de rede
					System.out.println(Mask);
					
					
					tamTxt1 = (byte)(comandoRecebido.charAt(9+3+tamIpServ+tamIpTerm+tamMask)-48); //Tamanho do texto 1
					txt1 =  comandoRecebido.substring(10+3+tamIpServ+tamIpTerm+tamMask,9+4+tamIpServ+tamIpTerm+tamMask+tamTxt1);//Texto 1
					System.out.println(txt1);
					
					tamTxt2 = (byte)(comandoRecebido.charAt(9+4+tamIpServ+tamIpTerm+tamMask+tamTxt1)-48); //Tamanho do texto2
					txt2 =  comandoRecebido.substring(10+4+tamIpServ+tamIpTerm+tamMask+tamTxt1,9+5+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2); //Texto2
					System.out.println(txt2);
				
					tamTxt3 = (byte)(comandoRecebido.charAt(9+5+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2)-48); //Tamanho do texto3
					txt3 =  comandoRecebido.substring(10+5+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2,9+6+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2+tamTxt3); //Texto3
					System.out.println(txt3);
				
					tamTxt4 = (byte)(comandoRecebido.charAt(9+6+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2+tamTxt3)-48); //Tamanho do texto 4
					txt4 =  comandoRecebido.substring(10+6+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2+tamTxt3,9+7+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2+tamTxt3+tamTxt4); //Texto 4
					System.out.println(txt4);

					tempExib = (byte)(comandoRecebido.charAt(9+7+tamIpServ+tamIpTerm+tamMask+tamTxt1+tamTxt2+tamTxt3+tamTxt4)-48); // Tempo de exibio
 					System.out.println(tempExib);
				}
				
				//Verifica se recebeu leitura de cdigo de barras
				else if (comandoRecebido.startsWith("#") ){
					System.out.println(comandoRecebido.substring(1));
					cod = comandoRecebido.substring(1);
					retCod = codigo.ConsultaCod(cod);//Efetua a consulta do cdigo recebido
					System.out.println(retCod);
					escreveSocket(retCod);			//Envia o resultado da consulta para escreveSocket 
				}
			}
		}catch(Exception e){
			conectado = false;
		}
		
	}
	
}
